<?php

namespace App\Http\Controllers;

use App\Models\Profesion;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Request;

class ProfesionController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index(): JsonResponse
    {
        $items = Profesion::all();

        return response()->json([
            'success' => true,
            'data' => $items,
            'message' => 'Registros obtenidos correctamente',
        ], 200);
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request): JsonResponse
    {
        $payload = $request->only((new Profesion())->getFillable());
        $profesion = Profesion::create($payload);

        return response()->json([
            'success' => true,
            'data' => $profesion,
            'message' => 'Registro creado correctamente',
        ], 201);
    }

    /**
     * Display the specified resource.
     */
    public function show(Profesion $profesion): JsonResponse
    {
        return response()->json([
            'success' => true,
            'data' => $profesion,
            'message' => 'Registro obtenido correctamente',
        ], 200);
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, Profesion $profesion): JsonResponse
    {
        $payload = $request->only((new Profesion())->getFillable());
        $profesion->update($payload);

        return response()->json([
            'success' => true,
            'data' => $profesion,
            'message' => 'Registro actualizado correctamente',
        ], 200);
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Profesion $profesion): JsonResponse
    {
        $profesion->delete();

        return response()->json([
            'success' => true,
            'message' => 'Registro eliminado correctamente',
        ], 200);
    }
}